import re

class MathOperations:
    def __init__(self):
        # Műveleti kulcsszavak listái
        self.add_keywords = ['add', 'össze', 'összeg', 'add össze', 'mennyi']
        self.subtract_keywords = ['subtract', 'vond', 'különbség', 'vonj']
        self.multiply_keywords = ['multiply', 'szorozd', 'szorzás']
        self.divide_keywords = ['divide', 'oszd', 'hányados']

    def handle_math_request(self, tokens):
        # Ellenőrizzük, hogy melyik művelet kulcsszava szerepel a tokenek között
        if any(keyword in tokens for keyword in self.add_keywords):
            return self.perform_addition(tokens)
        elif any(keyword in tokens for keyword in self.subtract_keywords):
            return self.perform_subtraction(tokens)
        elif any(keyword in tokens for keyword in self.multiply_keywords):
            return self.perform_multiplication(tokens)
        elif any(keyword in tokens for keyword in self.divide_keywords):
            return self.perform_division(tokens)
        else:
            return self.evaluate_expression(tokens)

    def evaluate_expression(self, tokens):
        # Kifejezés kiértékelése a tokenekből
        expression = " ".join(tokens)
        try:
            result = eval(expression.replace('/', '//'))  # Integer osztás
            return f"Az eredmény: {result}"
        except ZeroDivisionError:
            return "Nem oszthatunk nullával!"
        except Exception:
            return "Hiba történt a kifejezés kiértékelésekor."

    def perform_addition(self, tokens):
        numbers = self.extract_numbers(tokens)
        if len(numbers) < 2:
            return "Kérlek adj meg legalább két számot az összeadásához."
        result = sum(numbers)
        return f"Az összeg: {result}"

    def perform_subtraction(self, tokens):
        numbers = self.extract_numbers(tokens)
        if len(numbers) < 2:
            return "Kérlek adj meg legalább két számot a kivonáshoz."
        result = numbers[0] - sum(numbers[1:])
        return f"A különbség: {result}"

    def perform_multiplication(self, tokens):
        numbers = self.extract_numbers(tokens)
        if len(numbers) < 2:
            return "Kérlek adj meg legalább két számot a szorzáshoz."
        result = 1
        for number in numbers:
            result *= number
        return f"A szorzat: {result}"

    def perform_division(self, tokens):
        numbers = self.extract_numbers(tokens)
        if len(numbers) < 2:
            return "Kérlek adj meg legalább két számot az osztáshoz."
        if 0 in numbers[1:]:
            return "Nem oszthatunk nullával!"
        result = numbers[0]
        for number in numbers[1:]:
            result /= number
        return f"A hányados: {result}"

    def extract_numbers(self, tokens):
        # Számok kinyerése a tokenekből
        return [int(token) for token in tokens if token.isdigit()]
